#TO DO: Change to rate so that motion is same speed regardless of distance
# Create a crazy function to have word spiral/animate cooler
# Snap morphemes into "blanks"
# Read composition as creating it
# Eliminate erasing of other morphemes when click to speak


# Includes
import wx
import time
import math
import pyTTS
import random
import string
from cPickle import dump, load
from wxPython.wx import *

# Globals
tts=pyTTS.Create()
FILE_ADD = 100
FILE_SAVEDICT = 101
FILE_VIEWDICT = 102
FILE_LOADDICT = 103
FILE_CHECKUP = 104
FILE_EXIT = 106
HELP_INSTRUCTIONS = 110
HELP_ABOUT = 111

WordToBuild=['pre','dict','tion']
CurrentWord=['pre']
MySelection=['','','']
PossibleChoices=['','','','','']
MorphemeDictionary={}
TotalRight = 0
TotalAttempted = 0

# Morpheme Chunks
class MorphemeChunk(object):
	# Morpheme Chunk Initializer
	def __init__(self, word, x, y):
		self.word = word
		self.x = x
		self.y = y
		self.moving = False
		self.selected = False
		#self.blink = True

	# Move Function
	def MoveTo(self, x, y, rate):
		self.sx = self.x
		self.sy = self.y
		self.dx = x
		self.dy = y
		changex=abs(self.x-x)
		changey=abs(self.y-y)
		if changex>=changey:
			travelTime=changex/rate
		else:
			travelTime = changey/rate
		self.dt = travelTime
		self.startTime = time.time()
		self.moving = True

	# Painting function
	def Paint(self, dc):
		if self.moving:
			delta = time.time() - self.startTime

			if delta > self.dt:
				self.moving = False
				self.x = self.dx
				self.y = self.dy
			else:
				u = float(delta)/self.dt
				self.x = self.sx * (1-u) + self.dx * u
				self.y = self.sy * (1-u) + self.dy * u
			
			dc.SetFont(wx.Font(18, wx.ROMAN, wx.NORMAL, wx.BOLD))
			dc.SetTextForeground(wx.BLUE)
			dc.DrawText(self.word, self.x, self.y)
			
		elif self.selected:
			dc.SetFont(wx.Font(24, wx.ROMAN, wx.NORMAL, wx.NORMAL))
			self.selected = False
			dc.SetTextForeground(wx.RED)
			dc.DrawText(self.word, self.x, self.y)
			if self.x<=200 and self.y<=200 and self.word != WordToBuild[0]:
				tts.Speak('Sorry, you have selected the wrong morpheme.  You want to choose' + WordToBuild[0])
			elif self.x > 200 and self.x<=300 and self.y<=200 and self.word != WordToBuild[1]:
				tts.Speak('Sorry, you have selected the wrong morpheme.  You want to choose' + WordToBuild[1])
			elif self.x>300 and self.y<=200 and self.word != WordToBuild[2]:
				tts.Speak('Sorry, you have selected the wrong morpheme.  You want to choose' + WordToBuild[2])
			else:
				tts.Speak(self.word)

		else: 
			dc.SetFont(wx.Font(18, wx.ROMAN, wx.NORMAL, wx.NORMAL))
			dc.SetTextForeground(wx.RED)
			dc.DrawText(self.word, self.x, self.y)

		
class myApp(wx.App):
	# Initializations
	def OnInit(self):
		# Initialize the frame
		self.frame = wx.Frame(None, -1, 'Big Words', size=(500,500))
		self.frame.SetBackgroundColour('White')

		# Bind Mouse Events
		self.frame.Bind(wx.EVT_LEFT_DOWN, self.OnLeftDown)
		self.frame.Bind(wx.EVT_RIGHT_DOWN, self.OnRightDown)
		self.frame.Bind(wx.EVT_PAINT, self.OnPaint)
	
		# Create the file menu
		fileMenu = wxMenu()
		fileMenu.Append(FILE_ADD, 'Add Word')
		EVT_MENU(self, FILE_ADD, self.OnFileAdd)
		fileMenu.Append(FILE_SAVEDICT, 'Save Dictionary')
		EVT_MENU(self, FILE_SAVEDICT, self.OnSaveDictionary)
		fileMenu.Append(FILE_VIEWDICT, 'View Dictionary')
		EVT_MENU(self, FILE_VIEWDICT, self.OnViewDictionary)
		fileMenu.Append(FILE_LOADDICT, 'Load Dictionary')
		EVT_MENU(self, FILE_LOADDICT, self.OnLoadDictionary)
		fileMenu.Append(FILE_CHECKUP, 'Current Totals')
		EVT_MENU(self, FILE_CHECKUP, self.OnCheckUp)
		fileMenu.AppendSeparator()
		fileMenu.Append(FILE_EXIT, 'Exit')
		EVT_MENU(self, FILE_EXIT, self.OnFileExit)

		# Create the help menu
		helpMenu = wxMenu()
		helpMenu.Append(HELP_INSTRUCTIONS,'Instructions')
		EVT_MENU(self, HELP_INSTRUCTIONS, self.OnHelpInstructions)
		helpMenu.AppendSeparator()
		helpMenu.Append(HELP_ABOUT, 'About')
		EVT_MENU(self, HELP_ABOUT, self.OnHelpAbout)
		
		# Attach the menubar
		menuBar = wxMenuBar()
		menuBar.Append(fileMenu, 'File')
		menuBar.Append(helpMenu, 'Help')
		self.frame.SetMenuBar(menuBar)

		# Show frame
		self.frame.Show(True)

		global MorphemeDictionary		

		# Fill dictionary	
		f = file('dictionary.txt', 'r')
		f = open('dictionary.txt', 'r')		
		#text.txt is smaller file for debugging purposes
		
		# Set up dictionary with list of lists
		piece = ""
		li=[]
		sli=[]
		for line in f:
			for i in line:
				if i == ':':
					piece = piece.lstrip('\n')
					word=piece
					piece=""
				elif i ==',':
					sli.append(piece)
					piece=""
				elif i == ';':
					sli.append(piece)
					li.append(sli)
					sli=[]
					piece=""
				elif i =='.':
					sli.append(piece)
					li.append(sli)
					MorphemeDictionary[word]=li
					li = []
					sli=[]
					piece = ""
				else:
					piece = piece + i

		f.close()
		
		print MorphemeDictionary #for debugging

		global CurrentWord
		CurrentWord = self.SelectRandomWord()
		print CurrentWord #for debugging

		#Construct the Possibilities
		global PossibleChoices
		PossibleChoices = self.FillPossibilities()
		
		# for debugging
		print PossibleChoices #for debugging
		
		# Word List
		self.words = [MorphemeChunk(PossibleChoices[0], 75, 300), MorphemeChunk(PossibleChoices[1],145,300), MorphemeChunk(PossibleChoices[2],215,300), MorphemeChunk(PossibleChoices[3],285,300), MorphemeChunk(PossibleChoices[4],355,300)]

		# Initialize Timer Stuff
		self.rate = 2*math.pi
		self.timer = wx.Timer(self.frame)
		self.frame.Bind(wx.EVT_TIMER, self.OnTimer)
		self.timer.Start(150)

		return True

	# Randomly select word from Dictionary
	def SelectRandomWord(self):
		keylen=len(MorphemeDictionary)
		keys=MorphemeDictionary.keys()
		n=random.randint(0,keylen-1)
		index=keys[n]
		li= MorphemeDictionary[index]
		m=random.randint(0,len(li)-1)
		word=li[m]
		
		#CurrentWord[0]=word[0]
		#CurrentWord[1]=word[1]
		#CurrentWord[2]=word[2]

		return word
	# Function to fill Possibility List	
	def FillPossibilities(self):
		global WordToBuild
		print WordToBuild
		pc = []
		# First add the three in the word to build
		pc.append(WordToBuild[0])
		pc.append(WordToBuild[1])
		pc.append(WordToBuild[2])
		#PossibleChoices[3] = ''
		#PossibleChoices[4] = ''

		#Fill Possibilities List with two other random pieces(no repeats)
		keylen=len(MorphemeDictionary)
		keys=MorphemeDictionary.keys()
		Found = False
		Count = 3

		while Count<5:		
			n=random.randint(0,keylen-1)
			index=keys[n]
			li= MorphemeDictionary[index]
			m=random.randint(0,len(li)-1)
			word=li[m]
			g=random.randint(0,len(word)-1)
			chunk=word[g]

			for q in range(len(pc)):
				if pc[q] == chunk:
					Found = True

			if Found == False:
				pc.append(chunk)
				Count=Count+1
				
		# Quazi-Randomize
		pc.sort()
		pc.reverse()

		return pc
	# Function to handle menu exit: Presents a yes/no dialog
	def OnFileExit(self, e):
		dlg = wxMessageDialog(self.frame, 'Are you sure you want to exit?', 'Exit Program', wxYES_NO | wxICON_QUESTION)
		if dlg.ShowModal() == wxID_YES:
			dlg.Destroy()
			self.frame.Close(true)
		else:
			dlg.Destroy()

	# Function to handle menu about: Presents an info dialog
	def OnHelpAbout(self, e):
		dlg = wxMessageDialog(self.frame, 'The program was made by Kirstin Williams for COMP 290 and as a start to the Big Words Project', 'About', wxOK | wxICON_INFORMATION)
		dlg.ShowModal()
		dlg.Destroy()

	# Function to handle menu instructions: Presents an info dialog
	def OnHelpInstructions(self, e):
		dlg = wxMessageDialog(self.frame, 'This is a rough prototype of the Big Words Software.\n\nLeft-Clicks will cause whatever is under the mouse to be spoken.  If a morpheme receives a left-click, it is selected.  A right-click above a blank will move the morpheme to the blank.\n\nRight-clicks on "Next Exercise," "Check My Answers," or "Clear Blanks" will perform those actions.\n\nThe user may also add a word to the dictionary, save a dictionary, view a dictionary, load a dictionary, or check his/her current totals through the "File" menu.', 'Instructions', wxOK | wxICON_INFORMATION)
		dlg.ShowModal()
		dlg.Destroy()

	# Function to handle Saving a dictionary
	def OnSaveDictionary(self,e):
		# write to a file
		fp = file("MorphemeDictionary.pickle", "w")
		dump(MorphemeDictionary, fp)
		fp.close()

	# Function to handle View Dictionary
	def OnViewDictionary(self,e):
		print MorphemeDictionary

	# Function to handle Load Dictionary
	def OnLoadDictionary(self,e):
		global MorphemeDictionary
		
		fp = file("MorphemeDictionary.pickle", "r")
		MorphemeDictionary = load(fp)
		fp.close()

	# Function to display totals
	def OnCheckUp(self,e):
		global TotalRight
		global TotalAttempted
		s = 'Results\n'+'TotalRight: '+ str(TotalRight)+' TotalAttempted: ' + str(TotalAttempted)
		dlg = wxMessageDialog(self.frame, s, 'About', wxOK | wxICON_INFORMATION)
		dlg.ShowModal()
		dlg.Destroy()
		#print TotalRight
		#print TotalAttempted


	# Function to handle menu add: Presents a dialog that allows a user to enter a new word to the dictionary
	def OnFileAdd(self,e):
		global MorphemeDictionary
				
		dlg = wx.TextEntryDialog(None,'Enter the morpheme with which this word will be associated','Add a Word to Dictionary', '')
		ret = dlg.ShowModal()
		if ret == wx.ID_OK:
			index = dlg.GetValue()
			dlg.Destroy()
			#for debugging
			#print('You entered: %s\n' % index)
			dlg2 = wx.TextEntryDialog(None,'Enter the word with chunks separated by periods and ending with a semicolon (must be 3 syllables)','Add a Word to Dictionary', '')
			ret2 = dlg2.ShowModal()

			if ret2 == wx.ID_OK:
				
				tempword = dlg2.GetValue()
				# for debugging
				#print('You entered: %s\n' % tempword)
				piece=""
				li = []

				if index in MorphemeDictionary:
					entry = MorphemeDictionary[index]
				else:
					entry = []

				for i in tempword:
					if i =='.':
						li.append(piece)
						piece = ""
					elif i == ';':
						li.append(piece)
						if len(li) == 3:
							entry.append(li)
							MorphemeDictionary[index]=entry
						else:
							tts.Speak('I am sorry.  This version of Big Words will only accept three syllable word additions')
					else:
						piece = piece + i
			else:
				#for debugging
				print('No new words')
			dlg2.Destroy()
		else:
			#for debugging
			print('No new words')
		# for debugging
		print MorphemeDictionary
		

	# Function to handle timer
	def OnTimer(self, event):
		self.frame.Refresh()
		#self.frame.Refresh(False)
	
	# Function to Paint window
	def OnPaint(self, event):
		# Initialize canvas, etc
		can = self.frame
		pdc = wx.PaintDC(can)
		pdc.Clear()
		pdc.SetFont(wx.Font(18, wx.ROMAN, wx.NORMAL, wx.NORMAL))

		# Draw the exercise objective
		pdc.SetPen(wx.Pen("GREEN",1))
		pdc.DrawLine(0,0,500,0)
		pdc.DrawLine(0,50,500,50)
		pdc.DrawLine(0,0,0,50)
		pdc.DrawLine(500,0,500,50)
		pdc.SetTextForeground(wx.GREEN)
		pdc.DrawText('Choose the morphemes to make ' + WordToBuild[0] + ' ' + WordToBuild[1] + ' ' + WordToBuild[2],10,10)
		
		# Draw the "blanks" for the words
		pdc.SetPen(wx.Pen("BLACK", 4))
		pdc.DrawLine(150, 150, 200, 150)
		pdc.DrawLine(250, 150, 300, 150)
		pdc.DrawLine(350, 150, 400, 150)

		# Paint all the word chunks
		pdc.SetFont(wx.Font(12, wx.ROMAN, wx.NORMAL, wx.NORMAL))
		pdc.SetTextForeground(wx.RED)
		pdc.DrawText('Word Choices',175,250)
		pdc.SetPen(wx.Pen("RED", 2))
		pdc.DrawLine(50,275,415,275)
		pdc.DrawLine(50,350,415,350)
		pdc.DrawLine(50,274,50,350)
		pdc.DrawLine(415,275,415,350)
		for word in self.words:
			word.Paint(pdc)

		# Draw the "Buttons"
		pdc.SetFont(wx.Font(12, wx.ROMAN, wx.NORMAL, wx.NORMAL))
		pdc.SetTextForeground(wx.BLUE)
		pdc.SetPen(wx.Pen("BLUE",2))
		pdc.DrawLine(195,395,330,395)
		pdc.DrawLine(195,425,330,425)
		pdc.DrawLine(195,394,195,425)
		pdc.DrawLine(330,395,330,425)
		pdc.DrawText('Check My Answers',200,400)

		pdc.DrawLine(345,395,435,395)
		pdc.DrawLine(345,425,435,425)
		pdc.DrawLine(345,394,345,425)
		pdc.DrawLine(435,395,435,425)
		pdc.DrawText('Clear Blanks',350,400)

		pdc.DrawLine(85,395,180,395)
		pdc.DrawLine(85,425,180,425)
		pdc.DrawLine(85,394,85,425)
		pdc.DrawLine(180,395,180,425)
		pdc.DrawText('Next Exercise',90,400)		

	# Function to handle left mouse button down events
	def OnLeftDown(self, event):
		
		# Get the position
		pt=event.GetPosition()
		# for debugging
		#print pt

		# If the click was on/near the objective, read it out loud
		if pt[1]<50:
			tts.Speak('Choose the morphemes to make '+WordToBuild[0]+WordToBuild[1]+WordToBuild[2])
		elif pt[1]>=395 and pt[1]<=425 and pt[0]>=195 and pt[0]<=330:
			tts.Speak('Check my answers')
		elif pt[1]>=395 and pt[1]<=425 and pt[0]>=345 and pt[0]<=435:
			tts.Speak('Clear Blanks')
		elif pt[1]>=395 and pt[1] <=425 and pt[0]>=80 and pt[0]<=180:
			tts.Speak('Next Exercise')

		# Speak the morpheme that was clicked	
		elif pt[0] >= self.words[0].x and pt[0] <= (self.words[0].x+40) and pt[1] >= self.words[0].y and pt[1] <= (self.words[0].y+25):
			self.MorphemeSelected = 0
			self.words[0].selected = True
		elif pt[0] >= self.words[1].x and pt[0] <= (self.words[1].x+40) and pt[1] >= self.words[1].y and pt[1] <= (self.words[1].y+25):
			self.MorphemeSelected = 1
			self.words[1].selected = True
		elif pt[0] >= self.words[2].x and pt[0] <= (self.words[2].x+40) and pt[1] >= self.words[2].y and pt[1] <= (self.words[2].y+25):
			self.MorphemeSelected = 2
			self.words[2].selected = True
		elif pt[0] >= self.words[3].x and pt[0] <= (self.words[3].x+40) and pt[1] >= self.words[3].y and pt[1] <= (self.words[3].y+25):
			self.MorphemeSelected = 3
			self.words[3].selected = True
		elif pt[0] >= self.words[4].x and pt[0] <= (self.words[4].x+40) and pt[1] >= self.words[4].y and pt[1] <= (self.words[4].y+25):
			self.MorphemeSelected = 4
			self.words[4].selected = True
		elif pt[0] >= self.words[5].x and pt[0] <= (self.words[5].x+40) and pt[1] >= self.words[5].y and pt[1] <= (self.words[5].y+25):
			self.MorphemeSelected = 5
			self.words[5].selected = True	
		else:
			self.MorphemeSelected=10
			print 'Click Out of Range'
	
	# Function to handle right mouse click
	def OnRightDown(self, event):
		global MySelection
		global WordToBuild
		global PossibleChoices
		global TotalRight
		global TotalAttempted
		
		# Get the position of the click
		pt=event.GetPosition()
		rate=50
		Move = false
				
		# Set the final moved position accordingly
		if pt[0] <= 200 and pt[1]>=100 and pt[1]<=200:
			if MySelection[0] == '':
				x=160
				y=120
				Move = True
				MySelection[0]= self.words[self.MorphemeSelected].word
			else:
				tts.Speak('Sorry, this position is already occupied')
		elif pt[0]>200 and pt[0]<300 and pt[1]>=100 and pt[1]<=200:
			if MySelection[1] == '':
				x=260
				y=120
				Move = True
				MySelection[1]= self.words[self.MorphemeSelected].word
			else:
				tts.Speak('Sorry, this position is already occupied')
		elif pt[1]>=100 and pt[1]<=200:
			if MySelection[2] == '':
				x=360
				y=120
				Move = True
				MySelection[2]= self.words[self.MorphemeSelected].word
			else:
				tts.Speak('Sorry, this position is already occupied')

		# Create a new word to build and possibilities			
		elif pt[1]>=395 and pt[1]<=425 and pt[0]>=80 and pt[0]<=180:
			print 'next:' # for debugging
			
			TotalAttempted = TotalAttempted + 1

			WordToBuild = self.SelectRandomWord()			
			print WordToBuild # for debugging

			PossibleChoices = self.FillPossibilities()
			print PossibleChoices # for debugging
			
			MySelection[0]=''
			MySelection[1]=''
			MySelection[2]=''
			
			self.words = [MorphemeChunk(PossibleChoices[0], 75, 300), MorphemeChunk(PossibleChoices[1],145,300), MorphemeChunk(PossibleChoices[2],215,300), MorphemeChunk(PossibleChoices[3],285,300), MorphemeChunk(PossibleChoices[4],355,300)]

		# Randomly select word from Dictionary				
		elif pt[1]>=395 and pt[1]<=425 and pt[0]>=195 and pt[0]<=330:
			print 'check' # for debugging
			if MySelection[0]==WordToBuild[0] and MySelection[1]==WordToBuild[1] and MySelection[2]==WordToBuild[2]:
				tts.Speak('Great Job! You constructed'+MySelection[0]+MySelection[1]+MySelection[2])
				
				TotalRight = TotalRight + 1
				#MySelection=['','','']
			else:
				tts.Speak('Not Quite.  You constructed'+MySelection[0]+MySelection[1]+MySelection[2])

		# Clear Blanks and put words back in bank
		elif pt[1]>=395 and pt[1]<=425 and pt[0]>=345 and pt[0]<=435:
			print 'clear' # for debugging
			MySelection[0]=''
			MySelection[1]=''
			MySelection[2]=''
			self.words = [MorphemeChunk(PossibleChoices[0], 75, 300), MorphemeChunk(PossibleChoices[1],145,300), MorphemeChunk(PossibleChoices[2],215,300), MorphemeChunk(PossibleChoices[3],285,300), MorphemeChunk(PossibleChoices[4],355,300)]

		# Random Click
		else:
			print 'Click Out of Range'
		print MySelection			

		# Move the morphemes
		if Move == True:
			self.words[self.MorphemeSelected].MoveTo(x,y,rate)
			# for debugging
			#print pt

# Create application
if __name__ == '__main__':
	app = myApp(0)
	app.MainLoop()

